(function () {
    'use strict';


    TW.Runtime.Widgets.MaterialButtonWidget = function(){
        var thisWidget = this;

        var MaterialButtonCtrl = function($scope){
            //this widget refers to the scope of MaterialButtonWidget, you can use this also?

            $scope.count = thisWidget.getProperty('hoverCount');
            $scope.text = thisWidget.getProperty('Text');
            $scope.isWarn = thisWidget.getProperty('isWarn');
            $scope.isDisabled = thisWidget.getProperty('isDisabled');
            $scope.isPrimary = thisWidget.getProperty('isPrimary');
            $scope.isRaised = thisWidget.getProperty('isRaised');

            if($scope.count===undefined) $scope.count=999;

            $scope.doActionOnHover = function(){
                $scope.count++;
                thisWidget.setProperty('hoverCount', $scope.count);
                thisWidget.jqElement.triggerHandler('Hover');
            };

            $scope.doActionOnClick = function(){
                thisWidget.jqElement.triggerHandler('Clicked');
            };

            $scope.doActionOnDoubleClick = function(){
                thisWidget.jqElement.triggerHandler('DoubleClicked');
            };



        };
        this.runtimeProperties = function(){
            return{
              'needsError':true,
              'angularSupport':true
            };
        };

        this.renderHtml = function(){
          return '<div class="widget-content" ></div>';
        };

        this.afterRender = function(){

            angular.module(thisWidget.jqElementId, ['ngMaterial','ngAnimate','ngAria','material.svgAssetsCache']).controller('MaterialButtonCtrl', MaterialButtonCtrl);
            var jqElement = thisWidget.jqElement; //you can use thisWidget or this, they both refer to the TW.Runtime.Widgets.MaterialButtonWidget context;

            // var isRaised = this.getProperty('isRaised');
            // var isDisabled = this.getProperty('isDisabled');
            // var isWarn = this.getProperty('isWarn');
            // var isPrimary = this.getProperty('isPrimary');

            var html = '<div ng-controller="MaterialButtonCtrl" >'+
                        '<md-button class="btn1" ng-disabled="{{isDisabled}}" ng-class="{\'md-primary\' : (isPrimary === true), \'md-warn\' : (isWarn === true), \'md-raised\' : (isRaised === true)}" >{{text}}</md-button>'+
                       '</div>'
            jqElement.html(html);

            // customize based on syles
            // var mdButtonHTML = jqElement.find('md-button'); //get the md-button html element in jquery;
            //
            // if(isRaised) mdButtonHTML.addClass('md-raised');
            // if(isWarn) mdButtonHTML.addClass('md-warn');
            // if(isDisabled) mdButtonHTML.attr('ng-disabled',true);
            // if(isPrimary) mdButtonHTML.addClass('md-primary');
            // end customize based on syles


            angular.bootstrap(jqElement[0], [thisWidget.jqElementId]);
        };

        this.updateProperty = function(updatePropertyInfo){

        };
        this.beforeDestroy = function(){

        };
    };

})();
